/***************************************************************************
 *   Copyright (C) 2008  Antony Martin <martin(dot)antony(at)yahoo(dot)fr> *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 28/02/2008
   derniere modification : 28/02/2008 */

#ifndef SCEFRUSTUM_H
#define SCEFRUSTUM_H

#include <SCE/utils/SCEMatrix.h>
#include <SCE/utils/SCEVector.h>
#include <SCE/utils/SCEPlane.h>

#include <SCE/interface/SCEBoundingBox.h>

#ifdef __cplusplus
extern "C"
{
#endif

#define SCE_FRUSTUM_OUT 0
#define SCE_FRUSTUM_IN 1
#define SCE_FRUSTUM_PARTIALLY 2

typedef struct sce_sfrustum SCE_SFrustum;
struct sce_sfrustum
{
    SCE_SPlane planes[6];
};

/* initialise une structure de frustum */
void SCE_Frustum_Init (SCE_SFrustum*);

/* met a jour un frustum a partir de matrices de visualisation et projection */
void SCE_Frustum_MakeFromMatrices (SCE_SFrustum*, SCE_TMatrix4, SCE_TMatrix4);

/* indique si un point est dans le frustum */
int SCE_Frustum_PointIn (SCE_SFrustum*, float, float, float);
int SCE_Frustum_PointInv (SCE_SFrustum*, SCE_TVector3);

/* indique si une bounding box est dans un frustum */
int SCE_Frustum_BoundingBoxIn (SCE_SFrustum*, SCE_SBoundingBox*);

/* indique si un cube est dans le frustum */
int SCE_Frustum_CubeIn (SCE_SFrustum*, SCE_TVector3, float, float, float);
int SCE_Frustum_CubeInv (SCE_SFrustum*, SCE_TVector3, SCE_TVector3);

/* indique si une bounding sphere se trouve a l'interieur */
/*int SCE_Frustum_BoundingSphereIn (SCE_SFrustum*, SCE_SBoundingSphere*);*/

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* guard */
